Bug 1619543 - Assertion failure when system journal rotation fails
Summary: Assertion failure when system journal rotation fails
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: systemd
Version: 7.5
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: rc
: ---
Assignee: Jan Synacek
QA Contact: Frantisek Sumsal
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-08-21 07:28 UTC by Renaud Métrich
Modified: 2019-08-06 12:43 UTC (History)
3 users (show)

Fixed In Version: systemd-219-64.el7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-06 12:43:29 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2091 None None None 2019-08-06 12:43:49 UTC
Github systemd systemd pull 9893 None None None 2018-08-21 07:32:17 UTC

Description Renaud Métrich 2018-08-21 07:28:36 UTC
Description of problem:

The system journal rotation may fail when flushing to /var in the following piece of code:

int server_flush_to_var(Server *s) {
[...]
                server_rotate(s);
                server_vacuum(s);

                if (!s->system_journal) {
                        log_notice("Didn't flush runtime journal since rotation of system journal wasn't successful.");
                        r = -EIO;
HERE ---->              goto finish;
                }
[...]
finish:
        journal_file_post_change(s->system_journal);
[...]
This leads to calling journal_file_post_change with NULL pointer argument, causing the following assertion to fail:

void journal_file_post_change(JournalFile *f) {
        assert(f);
        [...]
}


Version-Release number of selected component (if applicable):

systemd-219 -> latest upstream


How reproducible:

Don't know


Additional info:

Upstream PR: https://github.com/systemd/systemd/pull/9893

Comment 2 Renaud Métrich 2018-09-03 06:49:35 UTC
Fixed in Upstream by fd790d6f09b10a87b007b71403cb018f18ff91c9

Comment 3 Jan Synacek 2018-09-03 08:26:27 UTC
https://github.com/lnykryn/systemd-rhel/pull/230

Comment 5 Lukáš Nykrýn 2019-02-11 09:44:21 UTC
fix merged to staging branch -> https://github.com/lnykryn/systemd-rhel/pull/230 -> post

Comment 9 errata-xmlrpc 2019-08-06 12:43:29 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:2091


Note You need to log in before you can comment on or make changes to this bug.